/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.40 from the
 * contents of baker.xs. Do not edit this file, edit baker.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "baker.xs"
#define PERL_NO_GET_CONTEXT     /* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"

#include <string.h>
#include "buffer.h"
#include "uri.h"
#include "cookie.h"

#if defined(_WIN32) || defined(_WIN64)
#define snprintf    _snprintf
#define vsnprintf   _vsnprintf
#define strcasecmp  _stricmp
#define strncasecmp _strnicmp
#else
#include <strings.h>
#endif


/*
 * Possible field names in a cookie.
 */
#define COOKIE_NAME_VALUE      "value"
#define COOKIE_NAME_DOMAIN     "Domain"
#define COOKIE_NAME_PATH       "Path"
#define COOKIE_NAME_MAX_AGE    "Max-Age"
#define COOKIE_NAME_EXPIRES    "Expires"
#define COOKIE_NAME_SECURE     "Secure"
#define COOKIE_NAME_HTTP_ONLY  "HttpOnly"
#define COOKIE_NAME_SAME_SITE  "SameSite"

static void get_encoded_value(pTHX_ SV* value, Buffer* encoded, int encode)
{
    SV* ref = 0;
    const char* vstr = 0;
    STRLEN vlen = 0;

    Buffer unencoded;
    buffer_reset(encoded);

    /* common case: just a string */
    if (!SvROK(value)) {
        vstr = SvPV_const(value, vlen);
        buffer_wrap(&unencoded, vstr, vlen);
        if (encode) {
            url_encode(&unencoded, encoded);
        } else {
            buffer_append_buf(encoded, &unencoded);
        }
        return;
    }

    /* less common case: a reference => multiple values */
    ref = SvRV(value);
    if (SvTYPE(ref) == SVt_PVAV) {
        AV* values = (AV*) ref;
        int count = 0;
        buffer_init(&unencoded , 0);
        while (1) {
            SV* elem = av_shift(values);
            if (!elem || elem == &PL_sv_undef) {
                break;
            }
            if (!SvOK(elem) || !SvPOK(elem)) {
                continue;
            }
            vstr = SvPV_const(elem, vlen);
            if (count) {
                buffer_append_str(&unencoded, "&", 1);
            }
            buffer_append_str(&unencoded, vstr, vlen);
            ++count;
        }
        if (encode) {
            url_encode(&unencoded, encoded);
        } else {
            buffer_append_buf(encoded, &unencoded);
        }
        buffer_fini(&unencoded);
    }

    /* don't know (yet) how to deal with other ref types */
}

/*
 * Given a name and a value, which can be a string or a hashref,
 * build a cookie with that data.
 */
static void build_cookie(pTHX_ SV* pname, SV* pvalue, Buffer* cookie)
{
    const char* nstr = 0;
    STRLEN nlen = 0;
    const char* vstr = 0;
    STRLEN vlen = 0;
    SV* ref = 0;
    HV* values = 0;
    SV** nval = 0;
    Buffer encoded;

    /* name not a valid string? bail out */
    if (!SvOK(pname) || !SvPOK(pname)) {
        return;
    }

    /* value not a valid scalar? bail out */
    if (!SvOK(pvalue)) {
        return;
    }

    nstr = SvPV_const(pname, nlen);

    if (SvPOK(pvalue)) {
        /* value is a simple string */
        vstr = SvPV_const(pvalue, vlen);
        cookie_put_string(cookie, nstr, nlen, vstr, vlen, 1, 1);
        return;
    }

    /* value not a valid ref? bail out */
    if (!SvROK(pvalue)) {
        return;
    }

    /* value not a valid hashref? bail out */
    ref = SvRV(pvalue);
    if (SvTYPE(ref) != SVt_PVHV) {
        return;
    }
    values = (HV*) ref;

    /* value for name not there? bail out */
    nval = hv_fetch(values, COOKIE_NAME_VALUE, sizeof(COOKIE_NAME_VALUE) -1, 0);
    if (!nval) {
        return;
    }

    buffer_init(&encoded , 0);

    /* first store cookie name and value, URL-encoding both */
    get_encoded_value(aTHX_ *nval, &encoded, 1);
    cookie_put_string(cookie, nstr, nlen, encoded.data, encoded.wpos, 1, 0);

    /* now iterate over all other values */
    hv_iterinit(values);
    while (nval) {
        SV* value = 0;
        I32 klen = 0;
        char* kstr = 0;
        HE* entry = hv_iternext(values);
        if (!entry) {
            /* no more hash keys */
            break;
        }

        kstr = hv_iterkey(entry, &klen);
        if (!kstr || klen <= 0) {
            /* invalid key */
            continue;
        }

        if (strcmp(kstr, COOKIE_NAME_VALUE) == 0) {
            /* name was already processed */
            continue;
        }

        value = hv_iterval(values, entry);
        if (!SvOK(value)) {
            continue;
        }

        /* value could be a string or an array, so need to encode it */
        get_encoded_value(aTHX_ value, &encoded, 0);
        vstr = encoded.data;
        vlen = encoded.wpos;
        if (vstr == 0) {
            continue;
        }

        /* TODO: should we skip if vstr is invalid / empty? */

        if        (strcasecmp(kstr, COOKIE_NAME_DOMAIN) == 0) {
            cookie_put_string (cookie, COOKIE_NAME_DOMAIN   , sizeof(COOKIE_NAME_DOMAIN)      - 1, vstr, vlen, 0, 0);
        } else if (strcasecmp(kstr, COOKIE_NAME_PATH      ) == 0) {
            cookie_put_string (cookie, COOKIE_NAME_PATH     , sizeof(COOKIE_NAME_PATH)        - 1, vstr, vlen, 0, 0);
        } else if (strcasecmp(kstr, COOKIE_NAME_MAX_AGE   ) == 0) {
            cookie_put_string (cookie, COOKIE_NAME_MAX_AGE  , sizeof(COOKIE_NAME_MAX_AGE)     - 1, vstr, vlen, 0, 0);
        } else if (strcasecmp(kstr, COOKIE_NAME_EXPIRES   ) == 0) {
            cookie_put_date (cookie, COOKIE_NAME_EXPIRES    , sizeof(COOKIE_NAME_EXPIRES)     - 1, vstr, vlen);
        } else if (strcasecmp(kstr, COOKIE_NAME_SECURE    ) == 0) {
            cookie_put_boolean(cookie, COOKIE_NAME_SECURE   , sizeof(COOKIE_NAME_SECURE)      - 1, SvTRUE(value));
        } else if (strcasecmp(kstr, COOKIE_NAME_HTTP_ONLY ) == 0) {
            cookie_put_boolean(cookie, COOKIE_NAME_HTTP_ONLY, sizeof(COOKIE_NAME_HTTP_ONLY)   - 1, SvTRUE(value));
        } else if (strcasecmp(kstr, COOKIE_NAME_SAME_SITE ) == 0) {
            cookie_put_string (cookie, COOKIE_NAME_SAME_SITE  , sizeof(COOKIE_NAME_SAME_SITE) - 1, vstr, vlen, 0, 0);
        }
    }
    buffer_fini(&encoded);
}

static int search_char(char c, const Buffer* buf, int start)
{
    int pos = -1;
    unsigned int j = 0;
    for (j = start; j < buf->wpos; ++j) {
        if (buf->data[j] == c) {
            pos = j;
            break;
        }
    }
    return pos;
}

/*
 * Given a string, parse it as a cookie into its component values
 * and return a hashref with them.
 *
 * Some standard field names have no value associated:
 *
 *   Secure
 *   HttpOnly
 *
 * Parameter allow_no_value controls what we do:
 *
 * =0: ignore these names, as if they had not been specified
 * >0: always treat these names as having a value of undef
 */
static HV* parse_cookie(pTHX_ SV* pstr, int allow_no_value)
{
    /* we will always return a hashref, maybe empty */
    HV* hv = newHV();

    do {
        const char* cstr = 0;
        STRLEN clen = 0;
        Buffer cookie;
        Buffer name;
        Buffer value;

        /* string not valid? bail out */
        if (!SvOK(pstr) || !SvPOK(pstr)) {
            break;
        }

        /* empty string? bail out */
        cstr = SvPV_const(pstr, clen);
        if (!cstr || !clen) {
            break;
        }

        /* wrap a Buffer around this string, so that we can
         * more easily work with it */
        buffer_wrap(&cookie, cstr, clen);

        /* prepare memory for name / value buffers */
        buffer_init(&name , 0);
        buffer_init(&value, 0);

        while (1) {
            int equals = 0;
            int pos = 0;
            AV* array = 0;
            int key = 0;
            unsigned int ini = 0;
            unsigned int end = 0;
            SV* ref = 0;

            /* reset buffers for name / value, avoiding memory reallocation */
            buffer_reset(&name);
            buffer_reset(&value);

            /* get the pair name=value, return whether we saw an equals sign */
            equals = cookie_get_pair(&cookie, &name, &value);

            /* got an empty name => ran out of data */
            if (name.wpos == 0) {
                break;
            }

            /* only first value seen for a name is kept */
            if (hv_exists(hv, name.data, name.wpos)) {
                continue;
            }

            if (!equals) {
                /* didn't see an equal sign => name with no value */
                if (allow_no_value) {
                    /* store a name => undef pair*/
                    SV* nil = newSV(0);
                    hv_store(hv, name.data, name.wpos, nil, 0);
                }
                continue;
            }

            pos = search_char('&', &value, value.rpos);
            if (pos < 0) {
                /* no & chars? simple string */
                SV* str = newSVpvn(value.data, value.wpos);
                hv_store(hv, name.data, name.wpos, str, 0);
                continue;
            }

            /* & chars => create arrayref */
            array = newAV();
            end = pos;
            while (1) {
                SV* str = 0;
                if (ini >= value.wpos) {
                    break;
                }
                str = sv_2mortal(newSVpvn(value.data + ini, end - ini));
                if (av_store(array, key, str)) {
                    SvREFCNT_inc(str);
                }
                ++key;
                ini = ++end;
                pos = search_char('&', &value, end);
                end = pos < 0 ? value.wpos : pos;
            }
            ref = newRV_noinc((SV*) array);
            hv_store(hv, name.data, name.wpos, ref, 0);
        }

        /* release memory for name / value buffers */
        buffer_fini(&value);
        buffer_fini(&name );
    } while (0);

    return hv;
}


#line 344 "baker.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 488 "baker.c"

XS_EUPXS(XS_HTTP__XSCookies_bake_cookie); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSCookies_bake_cookie)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, value");
    {
#line 342 "baker.xs"
    Buffer cookie;
#line 499 "baker.c"
	SV *	RETVAL;
	SV*	name = ST(0)
;
	SV*	value = ST(1)
;
#line 344 "baker.xs"
    buffer_init(&cookie, 0);
    build_cookie(aTHX_ name, value, &cookie);
    RETVAL = newSVpvn(cookie.data, cookie.wpos);
    buffer_fini(&cookie);
#line 510 "baker.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_HTTP__XSCookies_crush_cookie); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_HTTP__XSCookies_crush_cookie)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "str, ...");
    {
#line 353 "baker.xs"
    IV allow_no_value = 0;
#line 527 "baker.c"
	SV *	RETVAL;
	SV*	str = ST(0)
;
#line 355 "baker.xs"
    if (items > 1) {
        allow_no_value = SvIV(ST(1));
    }
    RETVAL = newRV_noinc((SV *) parse_cookie(aTHX_ str, allow_no_value));
#line 536 "baker.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_HTTP__XSCookies); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_HTTP__XSCookies)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("HTTP::XSCookies::bake_cookie", XS_HTTP__XSCookies_bake_cookie);
        newXS_deffile("HTTP::XSCookies::crush_cookie", XS_HTTP__XSCookies_crush_cookie);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

